import java.io.*;
import java.util.ArrayList;
import java.util.Random;

/**
 * Created by gda10jth on 2/8/16.
 */
public class CalcASMGenerator {
    public static void main(String[] args){
        int myCount = 170010;
        int limit = 5;
        while(nodeCount == 0 || (!(nodeCount - limit <= myCount && nodeCount >= myCount)
                && !(nodeCount + limit >= myCount && nodeCount <= myCount))) {
            new CalcASMGenerator(myCount);
        }
    }

    private static int nodeCount;
    private static int nodeCountAim;
    private Random rand;
    private String lastVarName;
    private int currentVarChar;

    private static final int MAX_DEPTH = 100;

    public CalcASMGenerator(int aim){
        nodeCountAim = aim -200 ;
        nodeCount = 0;
        rand = new Random();
        lastVarName = "a";
        currentVarChar = 0;
        try {
            //System.out.println("checking for filter:" + fullFilePath);
            // check if file exists
            File f = new File("/home/gda10jli/Documents/jastadddebugger-exjobb/calc.calc");
            PrintWriter writer = new PrintWriter(f, "UTF-8");
            createProgram(writer);
            nodeCount+=2;
            writer.close();
            System.out.println("Node count: " + nodeCount);
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
    }


    // Program ::= Expr;
    private void createProgram(PrintWriter writer){
        nodeCount++;
        createLet(writer, "", new ArrayList<>(), true, 0);
    }

    // Let : Expr ::= Binding* Expr;
    private void createLet(PrintWriter writer, String indent, ArrayList<String> bindings, boolean shouldIndent, int depth){
        ArrayList<String> localBindings = new ArrayList<>(bindings);
        nodeCount += 2;
        String tmpIndent = indent;
        if(!shouldIndent)
            tmpIndent = "";
        writer.println(tmpIndent + "let");
        createBindingList(writer, indent + "\t", localBindings, depth+1);
        writer.println(indent + "in");
        writer.print(indent + "\t");
        createExpr(writer, indent + "\t", localBindings, depth+1);
        writer.println();
        writer.println(indent + "end");
    }


    private void createBindingList(PrintWriter writer, String indent, ArrayList<String> bindings, int depth){
        int  n = rand.nextInt(10)+1;
        for(int i = 0; i< n; i++){
            nodeCount++;
            createBinding(writer, indent, bindings, depth+1);
        }
    }

    // Binding ::= IdDecl Expr;
    private void createBinding(PrintWriter writer, String indent, ArrayList<String> bindings, int depth){
        nodeCount+=2;
        String varName = getNextvarName();
        writer.print(indent + varName + " = ");
        createExpr(writer, indent, bindings, depth);
        writer.println();
        bindings.add(varName);
    }

    // abstract Expr;
    private void createExpr(PrintWriter writer, String indent, ArrayList<String> bindings, int depth){
        int nextExp = rand.nextInt(10);
        if(depth > MAX_DEPTH || nodeCount > nodeCountAim) {
            writer.print(rand.nextInt(50) + "");
            return;
        }
        if(nextExp < (2))
            createMul(writer, indent, bindings, depth+1);
        else if(nextExp < (4))
            createDiv(writer, indent, bindings, depth+1);
        else {
            nextExp = rand.nextInt(10);
            if(nextExp < (2)) {
                createLet(writer, indent + "\t", bindings, false, depth+1);
            }else if(nextExp < 8 && bindings.size() > 0){
                String var = bindings.get(0);
                bindings.remove(0);
                writer.print(var);
            }else{
                writer.print(rand.nextInt(50) + "");
            }
        }
    }

    // abstract BinExpr : Expr ::= Left:Expr Right:Expr;
    private void createMul(PrintWriter writer, String indent, ArrayList<String> bindings, int depth){
        nodeCount += 2;
        createExpr(writer, indent, bindings, depth+1);
        writer.print(" * ");
        createExpr(writer, indent, bindings, depth+1);
    }

    private void createDiv(PrintWriter writer, String indent, ArrayList<String> bindings, int depth){
        nodeCount += 2;
        createExpr(writer, indent, bindings, depth+1);
        writer.print(" / ");
        createExpr(writer, indent, bindings, depth+1);
    }

    private String getNextvarName(){
        String start = lastVarName.substring(0, currentVarChar);

        String end = currentVarChar == lastVarName.length() ? "" : lastVarName.substring(currentVarChar+1, lastVarName.length());
        char middleChar = lastVarName.charAt(currentVarChar);

        //System.out.println(":" + start + " - " + middleChar + " - " + end);
        String middle = "";
        if(middleChar == 'z'){
            if(currentVarChar == lastVarName.length()-1) {
                currentVarChar = 0;
                int k = lastVarName.length();
                lastVarName = "a";
                for(int i=0; i<k;i++)
                    lastVarName += "a";
            }
            else
                currentVarChar++;
            return getNextvarName();
        }else{
            middle = ++middleChar + "";
        }
        lastVarName = start + middle + end;
        return lastVarName;
    }
}